Version 4.0.0 of project44's API. If you're not familiar with project44, we recommend checking out our guides first: https://developers.project44.com/guides/shippers and https://developers.project44.com/guides/carriers.
Version 4.0.0 of project44's API. If you're not familiar with project44, we recommend checking out our guides first: https://developers.project44.com/guides/shippers and https://developers.project44.com/guides/carriers.
API used for registering and managing OAuth 2.0 client applications. See the "Authentication" section above for more information. To authorize API requests to project44 for an API integration, first your client application must be registered with project44, which will issue your application a client id and secret. These credentials can then be used to generate bearer tokens, which can be included on all other API requests to authorize your client application. The client application is authorized through the project44 user management UI as a machine user with username "app-{client_id}@client-applications.project44.com".
An admin user (with Movement user role "Customer Admin") must use HTTP Basic Authentication with this API to manage client applications. Basic Authentication is deprecated for all other APIs, besides token generation, in favor of passing the access token generated via OAuth 2.0.
API for OAuth 2.0 token generation. See the "Authentication" section above for more information. Once your client application is registered, you can use the token generation endpoint to authenticate with your application's client id and secret in exchange for a bearer token to be included on all other API requests to authenticate as that client application. The client application is authorized through the project44 user management UI as a machine user with username "app-{client_id}@client-applications.project44.com".
To generate an access token, you may authenticate your client application by providing its client id and secret either in the body of the request or in the form of HTTP Basic Authentication (but you may not use both ways in the same request).
curl -i -X GET \ 'https://na12.api.project44.com/services/booking/v1/bookings?attribute.name=string&attribute.values=string&pageNumber=1&pageSize=10&statuses=PROCESSING' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
{ "paginationInfo": { "pageSize": 0, "pageNumber": 0, "total": 0 }, "results": [ { … } ] }
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode.
Information about how a load should be handled in transportation, specific to mode.
curl -i -X POST \ https://na12.api.project44.com/services/booking/v1/bookings \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \ -H 'Content-Type: application/json' \ -d '{ "attributes": [ { "name": "attribute name", "values": [ "string value 1", "string value 2" ] } ], "capacityProviderIdentifier": { "type": "CARRIER_SCAC", "value": "IPSH" }, "carrierContacts": [ { "companyName": "Carrier Company Name", "givenName": "John", "familyName": "Hudson", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "j.hudson@carrier-company.com" } ], "totalRate": { "currency": "USD", "amount": 3500 }, "fuelSurchargeRate": { "currency": "USD", "amount": 275 }, "rateIdentifiers": [ { "source": "EXTERNAL", "type": "CONTRACT", "value": "contract-1234" } ], "expirationDateTime": "2026-03-11T08:30:00+00:00", "routeSegmentIds": [ "c1816420-f5a7-4321-89e3-3a8a4acab734" ], "notes": "Hello carrier! This is a note from the shipper, visible to you.", "shipmentDetails": [ { "pickupStopId": "62f54187-6379-42c4-ab02-7fcb2ca09f30", "deliveryStopId": "a4621429-0389-4b12-bf16-c7811d8721a8", "handlingUnits": [ { "monetaryValue": { "currency": "USD", "amount": 1200 }, "quantity": 10, "handlingUnitType": "PALLET", "stackable": true, "dimensions": { "length": 48, "width": 40, "height": 40, "unit": "IN" }, "weight": { "value": 2750, "unit": "LB" }, "items": [ { "description": "Custom accessories", "identifiers": [ { "type": "SALES_ORDER", "value": "SO-1a2b3c" } ], "unitQuantity": 12, "unitType": "BOX" } ] } ], "description": "Temperature-Sensitive Goods", "identifiers": [ { "type": "PURCHASE_ORDER", "value": "1234" } ], "accessorials": [ { "code": "REFRIGERATED", "details": { "min": 32, "max": 40, "unit": "FAHRENHEIT" } } ] } ], "shipperContactInfo": { "companyName": "Shipper Company Name", "givenName": "Jennifer", "familyName": "Smith", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "j.smith@shipper-company.com" }, "shippingDetails": { "parties": [ { "partyType": "SHIPPER", "contactInfo": { "companyName": "Shipper Company Name", "givenName": "Jennifer", "familyName": "Smith", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "j.smith@shipper-company.com" }, "addressInfo": { "addressLines": [ "400 Montgomery St", "2nd Floor" ], "postalCode": "94104", "city": "San Francisco", "state": "CA", "country": "US" }, "vatNumber": "vat-123" }, { "partyType": "BOOKING_AGENT", "contactInfo": { "companyName": "Notify Party Company Name", "givenName": "Henry", "familyName": "Jacobsen", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "h.jacobsen@notify-company.com" }, "addressInfo": { "addressLines": [ "222 W. Merchandise Mart Plaza", "Suite 1744" ], "postalCode": "60654", "city": "Chicago", "state": "IL", "country": "US" }, "vatNumber": "vat-234" } ], "serviceType": "PORT_TO_PORT", "cargoMeasurements": { "volume": { "value": 480, "unit": "CUBIC_FT" }, "weight": { "value": 2500, "unit": "KG" }, "dimensions": { "length": 20, "width": 6, "height": 4, "unit": "FT" } } } }'
Successful Response
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
An enumeration.
Method by which a shipper initiates a request for a booking.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
Method by which a carrier responds to bookings.
A free-text space for the carrier to provide extra information as to why they may reject the booking request.
Carrier-supplied identifiers for the shipment to be transported. Fully mutable.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
Once BOOKED, the booking initiates a tracked shipment within project44. With this identifier, the shipper may seek the trackable shipment through the rest of the project44 platform.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
A list of locations from/to which the shipment load is expected to be transported, organized as pairs.
The reason a carrier may opt not to accept a booking from a shipper.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
A descriptive state for a booking. Bookings start out in a PROCESSING state, only to be BOOKED or REJECTED by a carrier. A booking may enter the UNDER_REVIEW state after PROCESSING if the response must be polled after request. The state may shift to CANCELLED due to actions caused by either party in any state. A booking is EXPIRED if it sits in the PROCESSING or UNDER_REVIEW status upon the time which it is set to expire.
Shipper-supplied identifiers for the shipment to be transported. Passed through from the parenting shipment and shared with the carrier.
{ "attributes": [ { … } ], "apiConfiguration": { "bookingWebhookName": "string" }, "automatedFailureReason": "ERROR_CREDENTIALS", "bookingSourceMethod": "API", "capacityProviderIdentifier": { "type": "SCAC", "value": "string" }, "carrierContacts": [ { … } ], "carrierResponseMethod": "EMAIL", "carrierRejectionNotes": "string", "carrierProvidedIdentifiers": [ { … } ], "capacityProviderReferenceKeys": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "expirationDateTime": "2019-08-24T14:15:22Z", "fuelSurchargeRate": { "amount": 0, "currency": "USD" }, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "lastAcceptedDateTime": "2019-08-24T14:15:22Z", "masterShipmentId": "2e04ec4a-749a-4ef4-a452-b7dc8cca16aa", "notes": "string", "rateIdentifiers": [ { … } ], "routeSegmentIds": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "routeSegments": [ { … } ], "rejectionReason": "COST_NOT_AGREED", "shipmentId": "47efd5a2-af91-4417-950a-7f546cd1b5cf", "shipmentDetails": [ { … } ], "shipperContactInfo": { "companyName": "string", "email": "user@example.com", "familyName": "string", "givenName": "string", "mobilePhoneNumber": "string", "phoneNumber": "string" }, "shippingDetails": { "accessorials": [ … ], "flatbedType": "CONESTOGA", "loadPreference": "FULL", "trailerType": "FLATBED", "trailerDetails": "CONESTOGA", "trailerLength": { … }, "trailerVolume": { … } }, "status": "PROCESSING", "shipmentIdentifiers": [ { … } ], "totalRate": { "amount": 0, "currency": "USD" }, "transportationMode": "OCEAN" }
curl -i -X GET \ 'https://na12.api.project44.com/services/booking/v1/bookings/{bookingId}' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
Successful Response
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
An enumeration.
Method by which a shipper initiates a request for a booking.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
Method by which a carrier responds to bookings.
A free-text space for the carrier to provide extra information as to why they may reject the booking request.
Carrier-supplied identifiers for the shipment to be transported. Fully mutable.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
Once BOOKED, the booking initiates a tracked shipment within project44. With this identifier, the shipper may seek the trackable shipment through the rest of the project44 platform.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
A list of locations from/to which the shipment load is expected to be transported, organized as pairs.
The reason a carrier may opt not to accept a booking from a shipper.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
A descriptive state for a booking. Bookings start out in a PROCESSING state, only to be BOOKED or REJECTED by a carrier. A booking may enter the UNDER_REVIEW state after PROCESSING if the response must be polled after request. The state may shift to CANCELLED due to actions caused by either party in any state. A booking is EXPIRED if it sits in the PROCESSING or UNDER_REVIEW status upon the time which it is set to expire.
Shipper-supplied identifiers for the shipment to be transported. Passed through from the parenting shipment and shared with the carrier.
{ "attributes": [ { … } ], "apiConfiguration": { "bookingWebhookName": "string" }, "automatedFailureReason": "ERROR_CREDENTIALS", "bookingSourceMethod": "API", "capacityProviderIdentifier": { "type": "SCAC", "value": "string" }, "carrierContacts": [ { … } ], "carrierResponseMethod": "EMAIL", "carrierRejectionNotes": "string", "carrierProvidedIdentifiers": [ { … } ], "capacityProviderReferenceKeys": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "expirationDateTime": "2019-08-24T14:15:22Z", "fuelSurchargeRate": { "amount": 0, "currency": "USD" }, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "lastAcceptedDateTime": "2019-08-24T14:15:22Z", "masterShipmentId": "2e04ec4a-749a-4ef4-a452-b7dc8cca16aa", "notes": "string", "rateIdentifiers": [ { … } ], "routeSegmentIds": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "routeSegments": [ { … } ], "rejectionReason": "COST_NOT_AGREED", "shipmentId": "47efd5a2-af91-4417-950a-7f546cd1b5cf", "shipmentDetails": [ { … } ], "shipperContactInfo": { "companyName": "string", "email": "user@example.com", "familyName": "string", "givenName": "string", "mobilePhoneNumber": "string", "phoneNumber": "string" }, "shippingDetails": { "accessorials": [ … ], "flatbedType": "CONESTOGA", "loadPreference": "FULL", "trailerType": "FLATBED", "trailerDetails": "CONESTOGA", "trailerLength": { … }, "trailerVolume": { … } }, "status": "PROCESSING", "shipmentIdentifiers": [ { … } ], "totalRate": { "amount": 0, "currency": "USD" }, "transportationMode": "OCEAN" }
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode.
Information about how a load should be handled in transportation, specific to mode.
curl -i -X PUT \ 'https://na12.api.project44.com/services/booking/v1/bookings/{bookingId}' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \ -H 'Content-Type: application/json' \ -d '{ "attributes": [ { "name": "attribute name", "values": [ "string value 1", "string value 2" ] } ], "capacityProviderIdentifier": { "type": "CARRIER_SCAC", "value": "IPSH" }, "carrierContacts": [ { "companyName": "Carrier Company Name", "givenName": "John", "familyName": "Hudson", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "j.hudson@carrier-company.com" } ], "totalRate": { "currency": "USD", "amount": 3500 }, "rateIdentifiers": [ { "source": "EXTERNAL", "type": "CONTRACT", "value": "contract-1234" } ], "expirationDateTime": "2026-03-11T08:30:00+00:00", "routeSegmentIds": [ "c1816420-f5a7-4321-89e3-3a8a4acab734" ], "notes": "Hello carrier! This is a note from the shipper, visible to you.", "shipmentDetails": [ { "pickupStopId": "62f54187-6379-42c4-ab02-7fcb2ca09f30", "deliveryStopId": "a4621429-0389-4b12-bf16-c7811d8721a8", "handlingUnits": [ { "monetaryValue": { "currency": "USD", "amount": 1200 }, "quantity": 10, "handlingUnitType": "PALLET", "stackable": true, "dimensions": { "length": 48, "width": 40, "height": 40, "unit": "IN" }, "weight": { "value": 2750, "unit": "LB" }, "items": [ { "description": "Custom accessories", "identifiers": [ { "type": "SALES_ORDER", "value": "SO-1a2b3c" } ], "unitQuantity": 12, "unitType": "BOX" } ] } ], "description": "Temperature-Sensitive Goods", "identifiers": [ { "type": "PURCHASE_ORDER", "value": "1234" } ], "accessorials": [ { "code": "REFRIGERATED", "details": { "min": 32, "max": 40, "unit": "FAHRENHEIT" } } ] } ], "shipperContactInfo": { "companyName": "Shipper Company Name", "givenName": "Jennifer", "familyName": "Smith", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "j.smith@shipper-company.com" }, "shippingDetails": { "parties": [ { "partyType": "SHIPPER", "contactInfo": { "companyName": "Shipper Company Name", "givenName": "Jennifer", "familyName": "Smith", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "j.smith@shipper-company.com" }, "addressInfo": { "addressLines": [ "400 Montgomery St", "2nd Floor" ], "postalCode": "94104", "city": "San Francisco", "state": "CA", "country": "US" }, "vatNumber": "vat-123" }, { "partyType": "BOOKING_AGENT", "contactInfo": { "companyName": "Notify Party Company Name", "givenName": "Henry", "familyName": "Jacobsen", "phoneNumber": "1223334445", "mobilePhoneNumber": "1223334444", "email": "h.jacobsen@notify-company.com" }, "addressInfo": { "addressLines": [ "222 W. Merchandise Mart Plaza", "Suite 1744" ], "postalCode": "60654", "city": "Chicago", "state": "IL", "country": "US" }, "vatNumber": "vat-234" } ], "serviceType": "PORT_TO_PORT", "cargoMeasurements": { "volume": { "value": 480, "unit": "CUBIC_FT" }, "weight": { "value": 2500, "unit": "KG" }, "dimensions": { "length": 20, "width": 6, "height": 4, "unit": "FT" } } } }'
Successful Response
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
An enumeration.
Method by which a shipper initiates a request for a booking.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
Method by which a carrier responds to bookings.
A free-text space for the carrier to provide extra information as to why they may reject the booking request.
Carrier-supplied identifiers for the shipment to be transported. Fully mutable.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
Once BOOKED, the booking initiates a tracked shipment within project44. With this identifier, the shipper may seek the trackable shipment through the rest of the project44 platform.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
A list of locations from/to which the shipment load is expected to be transported, organized as pairs.
The reason a carrier may opt not to accept a booking from a shipper.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
A descriptive state for a booking. Bookings start out in a PROCESSING state, only to be BOOKED or REJECTED by a carrier. A booking may enter the UNDER_REVIEW state after PROCESSING if the response must be polled after request. The state may shift to CANCELLED due to actions caused by either party in any state. A booking is EXPIRED if it sits in the PROCESSING or UNDER_REVIEW status upon the time which it is set to expire.
Shipper-supplied identifiers for the shipment to be transported. Passed through from the parenting shipment and shared with the carrier.
{ "attributes": [ { … } ], "apiConfiguration": { "bookingWebhookName": "string" }, "automatedFailureReason": "ERROR_CREDENTIALS", "bookingSourceMethod": "API", "capacityProviderIdentifier": { "type": "SCAC", "value": "string" }, "carrierContacts": [ { … } ], "carrierResponseMethod": "EMAIL", "carrierRejectionNotes": "string", "carrierProvidedIdentifiers": [ { … } ], "capacityProviderReferenceKeys": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "expirationDateTime": "2019-08-24T14:15:22Z", "fuelSurchargeRate": { "amount": 0, "currency": "USD" }, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "lastAcceptedDateTime": "2019-08-24T14:15:22Z", "masterShipmentId": "2e04ec4a-749a-4ef4-a452-b7dc8cca16aa", "notes": "string", "rateIdentifiers": [ { … } ], "routeSegmentIds": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "routeSegments": [ { … } ], "rejectionReason": "COST_NOT_AGREED", "shipmentId": "47efd5a2-af91-4417-950a-7f546cd1b5cf", "shipmentDetails": [ { … } ], "shipperContactInfo": { "companyName": "string", "email": "user@example.com", "familyName": "string", "givenName": "string", "mobilePhoneNumber": "string", "phoneNumber": "string" }, "shippingDetails": { "accessorials": [ … ], "flatbedType": "CONESTOGA", "loadPreference": "FULL", "trailerType": "FLATBED", "trailerDetails": "CONESTOGA", "trailerLength": { … }, "trailerVolume": { … } }, "status": "PROCESSING", "shipmentIdentifiers": [ { … } ], "totalRate": { "amount": 0, "currency": "USD" }, "transportationMode": "OCEAN" }
curl -i -X POST \ 'https://na12.api.project44.com/services/booking/v1/bookings/{bookingId}/cancellations' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
Successful Response
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
An enumeration.
Method by which a shipper initiates a request for a booking.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
Method by which a carrier responds to bookings.
A free-text space for the carrier to provide extra information as to why they may reject the booking request.
Carrier-supplied identifiers for the shipment to be transported. Fully mutable.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
Once BOOKED, the booking initiates a tracked shipment within project44. With this identifier, the shipper may seek the trackable shipment through the rest of the project44 platform.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
A list of locations from/to which the shipment load is expected to be transported, organized as pairs.
The reason a carrier may opt not to accept a booking from a shipper.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
A descriptive state for a booking. Bookings start out in a PROCESSING state, only to be BOOKED or REJECTED by a carrier. A booking may enter the UNDER_REVIEW state after PROCESSING if the response must be polled after request. The state may shift to CANCELLED due to actions caused by either party in any state. A booking is EXPIRED if it sits in the PROCESSING or UNDER_REVIEW status upon the time which it is set to expire.
Shipper-supplied identifiers for the shipment to be transported. Passed through from the parenting shipment and shared with the carrier.
{ "attributes": [ { … } ], "apiConfiguration": { "bookingWebhookName": "string" }, "automatedFailureReason": "ERROR_CREDENTIALS", "bookingSourceMethod": "API", "capacityProviderIdentifier": { "type": "SCAC", "value": "string" }, "carrierContacts": [ { … } ], "carrierResponseMethod": "EMAIL", "carrierRejectionNotes": "string", "carrierProvidedIdentifiers": [ { … } ], "capacityProviderReferenceKeys": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "expirationDateTime": "2019-08-24T14:15:22Z", "fuelSurchargeRate": { "amount": 0, "currency": "USD" }, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "lastAcceptedDateTime": "2019-08-24T14:15:22Z", "masterShipmentId": "2e04ec4a-749a-4ef4-a452-b7dc8cca16aa", "notes": "string", "rateIdentifiers": [ { … } ], "routeSegmentIds": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "routeSegments": [ { … } ], "rejectionReason": "COST_NOT_AGREED", "shipmentId": "47efd5a2-af91-4417-950a-7f546cd1b5cf", "shipmentDetails": [ { … } ], "shipperContactInfo": { "companyName": "string", "email": "user@example.com", "familyName": "string", "givenName": "string", "mobilePhoneNumber": "string", "phoneNumber": "string" }, "shippingDetails": { "accessorials": [ … ], "flatbedType": "CONESTOGA", "loadPreference": "FULL", "trailerType": "FLATBED", "trailerDetails": "CONESTOGA", "trailerLength": { … }, "trailerVolume": { … } }, "status": "PROCESSING", "shipmentIdentifiers": [ { … } ], "totalRate": { "amount": 0, "currency": "USD" }, "transportationMode": "OCEAN" }
curl -i -X POST \ 'https://na12.api.project44.com/services/booking/v1/bookings/{bookingId}/carrier-notices' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
Successful Response
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
An enumeration.
Method by which a shipper initiates a request for a booking.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
Method by which a carrier responds to bookings.
A free-text space for the carrier to provide extra information as to why they may reject the booking request.
Carrier-supplied identifiers for the shipment to be transported. Fully mutable.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
Once BOOKED, the booking initiates a tracked shipment within project44. With this identifier, the shipper may seek the trackable shipment through the rest of the project44 platform.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
A list of locations from/to which the shipment load is expected to be transported, organized as pairs.
The reason a carrier may opt not to accept a booking from a shipper.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
A descriptive state for a booking. Bookings start out in a PROCESSING state, only to be BOOKED or REJECTED by a carrier. A booking may enter the UNDER_REVIEW state after PROCESSING if the response must be polled after request. The state may shift to CANCELLED due to actions caused by either party in any state. A booking is EXPIRED if it sits in the PROCESSING or UNDER_REVIEW status upon the time which it is set to expire.
Shipper-supplied identifiers for the shipment to be transported. Passed through from the parenting shipment and shared with the carrier.
{ "attributes": [ { … } ], "apiConfiguration": { "bookingWebhookName": "string" }, "automatedFailureReason": "ERROR_CREDENTIALS", "bookingSourceMethod": "API", "capacityProviderIdentifier": { "type": "SCAC", "value": "string" }, "carrierContacts": [ { … } ], "carrierResponseMethod": "EMAIL", "carrierRejectionNotes": "string", "carrierProvidedIdentifiers": [ { … } ], "capacityProviderReferenceKeys": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "expirationDateTime": "2019-08-24T14:15:22Z", "fuelSurchargeRate": { "amount": 0, "currency": "USD" }, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "lastAcceptedDateTime": "2019-08-24T14:15:22Z", "masterShipmentId": "2e04ec4a-749a-4ef4-a452-b7dc8cca16aa", "notes": "string", "rateIdentifiers": [ { … } ], "routeSegmentIds": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "routeSegments": [ { … } ], "rejectionReason": "COST_NOT_AGREED", "shipmentId": "47efd5a2-af91-4417-950a-7f546cd1b5cf", "shipmentDetails": [ { … } ], "shipperContactInfo": { "companyName": "string", "email": "user@example.com", "familyName": "string", "givenName": "string", "mobilePhoneNumber": "string", "phoneNumber": "string" }, "shippingDetails": { "accessorials": [ … ], "flatbedType": "CONESTOGA", "loadPreference": "FULL", "trailerType": "FLATBED", "trailerDetails": "CONESTOGA", "trailerLength": { … }, "trailerVolume": { … } }, "status": "PROCESSING", "shipmentIdentifiers": [ { … } ], "totalRate": { "amount": 0, "currency": "USD" }, "transportationMode": "OCEAN" }
As a Carrier, respond to a booking request, or update an existing response.
ACCEPT a booking by providing any identifiers applicable to the Shipment across applicable route-segments in the form of a BookingResponse. All route-segments must be present in the response, even to specify there are no identifiers known at the time of acceptance. A Carrier may update identifiers with this call if they have already accepted a booking.
REJECT a booking by selecting a reason for rejection in the form of a BookingRejection.
A Carrier may not PUT a Rejection to a booking after they have already accepted it.
Carrier response in the form of an Acceptance with identification information or a Rejection with a reason.
Further response details applicable to the booking.
Further response details applicable to the booking.
List of the accepted dates to travel the route-segments requested by the shipper. All of the route-segments requested by the shipper in the booking must be included.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
curl -i -X PUT \ 'https://na12.api.project44.com/services/booking/v1/bookings/{bookingId}/responses' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \ -H 'Content-Type: application/json' \ -d '{ "shipmentIdentifiers": [ { "type": "AIR_WAYBILL", "value": "AW_123456789" } ], "routeSegments": [ { "routeSegmentId": "807127ac-e8dc-4a69-9032-48bcd62116a8", "fromDate": "2092-12-10", "toDate": "2092-12-12" } ], "details": {} }'
Successful Response
A shipper-provided list of custom key-value list pairs relevant to the booking which are shared with the carrier.
An enumeration.
Method by which a shipper initiates a request for a booking.
A Capacity Provider identifier object used to identify a carrier or a broker responsible for transporting a shipment, containing two key-value pairs: type and value.
Individuals representing the carrier to whom the booking should be sent. These contacts are not notify parties nor any individuals working with or on behalf of the shipper.
Method by which a carrier responds to bookings.
A free-text space for the carrier to provide extra information as to why they may reject the booking request.
Carrier-supplied identifiers for the shipment to be transported. Fully mutable.
A capacity-provider supplied list of custom key-value list pairs relevant to the booking which are shared with the shipper and will be used to initiate tracking within the project44 platform on top of shipper provided reference keys. If there is more than 25 reference keys in total, then excessive reference keys from this list will be omitted from the tracking initiation.
The datetime of expiration for this request from the shipper to the carrier. A timezone offset is required.
Once BOOKED, the booking initiates a tracked shipment within project44. With this identifier, the shipper may seek the trackable shipment through the rest of the project44 platform.
An optional, shipper-provided free-text space for notes on the shipment.
A list of at least one identifier as reference to the original source of the rate applicable to the booking. Typically a spot quote or a contract ID.
A list of locations from/to which the shipment load is expected to be transported, organized as pairs.
The reason a carrier may opt not to accept a booking from a shipper.
The project44-generated identifier for the shipment which parents the booking. Optional when created with a Shipment in one request. Required when creating a booking separately.
Descriptive information about the load to be transported; if the load does not change between route segments, this body is expected to be the same across each route-segment body.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
Information about how a load should be handled in transportation, specific to mode; When carrier respond to booking, this field also contains specific carrier's response information.
A descriptive state for a booking. Bookings start out in a PROCESSING state, only to be BOOKED or REJECTED by a carrier. A booking may enter the UNDER_REVIEW state after PROCESSING if the response must be polled after request. The state may shift to CANCELLED due to actions caused by either party in any state. A booking is EXPIRED if it sits in the PROCESSING or UNDER_REVIEW status upon the time which it is set to expire.
Shipper-supplied identifiers for the shipment to be transported. Passed through from the parenting shipment and shared with the carrier.
{ "attributes": [ { … } ], "apiConfiguration": { "bookingWebhookName": "string" }, "automatedFailureReason": "ERROR_CREDENTIALS", "bookingSourceMethod": "API", "capacityProviderIdentifier": { "type": "SCAC", "value": "string" }, "carrierContacts": [ { … } ], "carrierResponseMethod": "EMAIL", "carrierRejectionNotes": "string", "carrierProvidedIdentifiers": [ { … } ], "capacityProviderReferenceKeys": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "expirationDateTime": "2019-08-24T14:15:22Z", "fuelSurchargeRate": { "amount": 0, "currency": "USD" }, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "lastAcceptedDateTime": "2019-08-24T14:15:22Z", "masterShipmentId": "2e04ec4a-749a-4ef4-a452-b7dc8cca16aa", "notes": "string", "rateIdentifiers": [ { … } ], "routeSegmentIds": [ "497f6eca-6276-4993-bfeb-53cbbbba6f08" ], "routeSegments": [ { … } ], "rejectionReason": "COST_NOT_AGREED", "shipmentId": "47efd5a2-af91-4417-950a-7f546cd1b5cf", "shipmentDetails": [ { … } ], "shipperContactInfo": { "companyName": "string", "email": "user@example.com", "familyName": "string", "givenName": "string", "mobilePhoneNumber": "string", "phoneNumber": "string" }, "shippingDetails": { "accessorials": [ … ], "flatbedType": "CONESTOGA", "loadPreference": "FULL", "trailerType": "FLATBED", "trailerDetails": "CONESTOGA", "trailerLength": { … }, "trailerVolume": { … } }, "status": "PROCESSING", "shipmentIdentifiers": [ { … } ], "totalRate": { "amount": 0, "currency": "USD" }, "transportationMode": "OCEAN" }
The type of the custom shipment identifier to search against.
The value of the custom shipment identifier to search for; this filter is non-partial.
The values of the custom shipment attribute to search for; this filter is non-partial.
curl -i -X GET \ 'https://na12.api.project44.com/services/booking/v1/shipments?attribute.name=string&attribute.values=string&identifier.type=AIR_WAYBILL&identifier.value=string&pageNumber=1&pageSize=10' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
{ "paginationInfo": { "pageSize": 0, "pageNumber": 0, "total": 0 }, "results": [ { … } ] }
An optional user-defined set of custom attributes to associate with this shipment. These are descriptors and identifiers which apply to the entire shipment and they are not shared with any carriers.
A list of bookings related to the shipment to create at the same time.
The descriptive name or otherwise human-readable description of the shipment created; this is not visible to the carrier.
An optional, shipper-provided free-text space for notes on the shipment.
curl -i -X POST \ https://na12.api.project44.com/services/booking/v1/shipments \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \ -H 'Content-Type: application/json' \ -d '{ "identifiers": [ { "type": "CUSTOMER_REFERENCE", "value": "SHIPMENT-12345" } ], "routeInfo": { "stops": [ { "id": "e379cef8-5af6-47e3-9c8f-052faa2c5061", "type": "PICKUP", "arrivalDate": "2092-12-10", "location": { "address": { "addressLines": [ "222 W. Merchandise Mart Plaza", "Suite 1744" ], "postalCode": "60654", "city": "Chicago", "state": "IL", "country": "US" } } }, { "id": "b996b45d-94cb-42ac-aa6f-cd8c7cfe7a5b", "type": "DELIVERY", "arrivalDate": "2092-12-12", "location": { "address": { "addressLines": [ "3800 N Lamar Blvd", "Suite 210" ], "postalCode": "78756", "city": "Austin", "state": "TX", "country": "US" } } } ], "routeSegments": [ { "fromStopId": "e379cef8-5af6-47e3-9c8f-052faa2c5061", "toStopId": "b996b45d-94cb-42ac-aa6f-cd8c7cfe7a5b" } ] }, "attributes": [ { "name": "attribute name", "values": [ "string value 1", "string value 2" ] } ] }'
Success
An optional user-defined set of custom attributes to associate with this shipment. These are descriptors and identifiers which apply to the entire shipment and they are not shared with any carriers.
The descriptive name or otherwise human-readable description of the shipment created; this is not visible to the carrier.
An optional, shipper-provided free-text space for notes on the shipment.
{ "identifiers": [ { … } ], "routeInfo": { "stops": [ … ], "routeSegments": [ … ] }, "attributes": [ { … } ], "name": "shipmentName", "notes": "shipmentNotes", "bookings": [ { … } ], "id": "d1b4c593-7b6a-49d2-8c8e-12c914c20016", "createdDateTime": "2024-03-25T10:39:05", "lastModifiedDateTime": "2024-03-25T10:39:05" }
curl -i -X GET \ 'https://na12.api.project44.com/services/booking/v1/shipments/{shipmentId}' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
Successful Response
An optional user-defined set of custom attributes to associate with this shipment. These are descriptors and identifiers which apply to the entire shipment and they are not shared with any carriers.
The descriptive name or otherwise human-readable description of the shipment created; this is not visible to the carrier.
An optional, shipper-provided free-text space for notes on the shipment.
{ "attributes": [ { … } ], "bookings": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "identifiers": [ { … } ], "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "name": "string", "notes": "string", "routeInfo": { "routeSegments": [ … ], "stops": [ … ] } }
An optional user-defined set of custom attributes to associate with this shipment. These are descriptors and identifiers which apply to the entire shipment and they are not shared with any carriers.
The descriptive name or otherwise human-readable description of the shipment created; this is not visible to the carrier.
An optional, shipper-provided free-text space for notes on the shipment.
curl -i -X PUT \ 'https://na12.api.project44.com/services/booking/v1/shipments/{shipmentId}' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \ -H 'Content-Type: application/json' \ -d '{ "identifiers": [ { "type": "CUSTOMER_REFERENCE", "value": "SHIPMENT-12345" } ], "routeInfo": { "stops": [ { "id": "e379cef8-5af6-47e3-9c8f-052faa2c5061", "type": "PICKUP", "arrivalDate": "2092-12-10", "contacts": [], "accessorials": [], "location": { "identifiers": [], "address": { "addressLines": [ "222 W. Merchandise Mart Plaza", "Suite 1744" ], "postalCode": "60654", "city": "Chicago", "state": "IL", "country": "US" } } }, { "id": "b996b45d-94cb-42ac-aa6f-cd8c7cfe7a5b", "type": "DELIVERY", "arrivalDate": "2092-12-12", "contacts": [], "accessorials": [], "location": { "identifiers": [], "address": { "addressLines": [ "3800 N Lamar Blvd", "Suite 210" ], "postalCode": "78756", "city": "Austin", "state": "TX", "country": "US" } } } ], "routeSegments": [ { "fromStopId": "e379cef8-5af6-47e3-9c8f-052faa2c5061", "toStopId": "b996b45d-94cb-42ac-aa6f-cd8c7cfe7a5b" } ] }, "attributes": [ { "name": "attribute name", "values": [ "string value 1", "string value 2" ] } ], "bookings": [] }'
Success
An optional user-defined set of custom attributes to associate with this shipment. These are descriptors and identifiers which apply to the entire shipment and they are not shared with any carriers.
The descriptive name or otherwise human-readable description of the shipment created; this is not visible to the carrier.
An optional, shipper-provided free-text space for notes on the shipment.
{ "identifiers": [ { … } ], "routeInfo": { "stops": [ … ], "routeSegments": [ … ] }, "attributes": [ { … } ], "name": "shipmentName", "notes": "shipmentNotes", "bookings": [ { … } ], "id": "d1b4c593-7b6a-49d2-8c8e-12c914c20016", "createdDateTime": "2024-03-25T10:39:05", "lastModifiedDateTime": "2024-03-25T10:39:05" }
curl -i -X POST \ 'https://na12.api.project44.com/services/booking/v1/shipments/{shipmentId}/bookings/cancellations' \ -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'
Successful Response
An optional user-defined set of custom attributes to associate with this shipment. These are descriptors and identifiers which apply to the entire shipment and they are not shared with any carriers.
The descriptive name or otherwise human-readable description of the shipment created; this is not visible to the carrier.
An optional, shipper-provided free-text space for notes on the shipment.
{ "attributes": [ { … } ], "bookings": [ { … } ], "createdDateTime": "2019-08-24T14:15:22Z", "identifiers": [ { … } ], "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "lastModifiedDateTime": "2019-08-24T14:15:22Z", "name": "string", "notes": "string", "routeInfo": { "routeSegments": [ … ], "stops": [ … ] } }